﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDeckerBus
{
    internal class DrawningDoubleDeckerBus : DrawningBus
    {
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автобуса</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="bodyKit">Признак наличия обвеса</param>
        /// <param name="secondFloor">Признак наличия второго этажа</param>
        /// <param name="line">Признак наличия полосы</param>
        public DrawningDoubleDeckerBus(int speed, float weight, Color bodyColor, Color dopColor, bool secondFloor, bool bodyKit, bool stair) :
        base(speed, weight, bodyColor, 120, 92)
        {
            Bus = new EntityDoubleDeckerBus(speed, weight, bodyColor, dopColor, secondFloor, bodyKit, stair);
        }
        public override void DrawTransport(Graphics g)
        {
            if (Bus is not EntityDoubleDeckerBus doubleDeckerBus)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush dopBrush = new SolidBrush(doubleDeckerBus.DopColor);
            if (doubleDeckerBus.SecondFloor)
            {
                //кузов
                g.FillRectangle(dopBrush, _startPosX, _startPosY, 115, 40);
                //граница автобуса
                g.DrawRectangle(pen, _startPosX, _startPosY, 115, 40);
                //стекла
                Brush brBlue = new SolidBrush(Color.LightBlue);
                g.FillEllipse(brBlue, _startPosX + 2, _startPosY + 2, 12, 20);
                g.FillEllipse(brBlue, _startPosX + 20, _startPosY + 2, 12, 20);
                g.FillEllipse(brBlue, _startPosX + 55, _startPosY + 2 , 12, 20);
                g.FillEllipse(brBlue, _startPosX + 70, _startPosY + 2, 12, 20);
                g.FillEllipse(brBlue, _startPosX + 85, _startPosY + 2, 12, 20);
                g.FillEllipse(brBlue, _startPosX + 100 , _startPosY + 2, 12, 20);
                
            }
            _startPosY += 40;
            base.DrawTransport(g);
            _startPosY -= 40;
            Brush brBlack = new SolidBrush(Color.Black);
            if (doubleDeckerBus.Stair)
            {
                g.FillRectangle(brBlack, _startPosX + 73, _startPosY + 57, 4, 5);
                g.FillRectangle(brBlack, _startPosX + 76, _startPosY + 53, 3, 5);
                g.FillRectangle(brBlack, _startPosX + 78, _startPosY + 49, 4, 5);
                g.FillEllipse(brBlack, _startPosX + 73, _startPosY + 57, 8, 5);
                g.FillEllipse(brBlack, _startPosX + 76, _startPosY + 53, 6, 5);
                g.FillEllipse(brBlack, _startPosX + 78, _startPosY + 49, 4, 5);
            }
            Brush brGray = new SolidBrush(Color.DarkGray);
            if (doubleDeckerBus.BodyKit)
            {
                g.FillRectangle(brGray, _startPosX, _startPosY + 75, 14, 8);
                g.FillRectangle(brGray, _startPosX + 32, _startPosY + 75, 53, 8);
                g.FillRectangle(brGray, _startPosX + 102, _startPosY + 75, 14, 8);
            }
        }

    }
}
