﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDeckerBus
{
    internal class EntityDoubleDeckerBus : EntityBus
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; private set; }
        /// <summary>
        /// Признак наличия обвеса
        /// </summary>
        public bool SecondFloor{ get; private set; }
        /// <summary>
        /// Признак наличия антикрыла
        /// </summary>
        public bool BodyKit { get; private set; }
        /// <summary>
        /// Признак наличия гоночной полосы
        /// </summary>
        public bool Stair { get; private set; }
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автобуса</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="secondFloor">Признак наличия второго этажа</param>
        /// <param name="bodyKit">Признак наличия обвеса</param>
        /// <param name="stair">Признак наличия лестницы</param>
        public EntityDoubleDeckerBus(int speed, float weight, Color bodyColor, Color dopColor, bool secondFloor, bool bodyKit, bool stair) :
        base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            SecondFloor = secondFloor;
            BodyKit = bodyKit;
            Stair = stair;
        }

    }
}
